select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from an.dtdesmama) < 10
        then '0'|| extract(day from an.dtdesmama)
      else extract(day from an.dtdesmama) end)
    || '/'
    || (case
      when extract(month from an.dtdesmama) < 10
        then '0' || extract(month from an.dtdesmama)
      else extract(month from an.dtdesmama) end)
    || '/'
    || extract(year from an.dtdesmama) as data_desmama
  , cast(p.peso as integer) as peso_desmama
from animal an
  join peso p on p.cdanimal = an.cdanimal and p.dtpeso = an.dtdesmama
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is null
  and an.dtdesmama is not null
  --AN.DTDESMAMA BETWEEN (CURRENT_DATE - 31) AND (CURRENT_DATE)
