select
  (select first 1 idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from l.dtleite) < 10
        then '0'|| extract(day from l.dtleite)
      else extract(day from l.dtleite) end)
    || '/'
    || (case
      when extract(month from l.dtleite) < 10
        then '0' || extract(month from l.dtleite)
      else extract(month from l.dtleite) end)
    || '/'
    || extract(year from l.dtleite) as data_medicao_leite
  , l.pesototal as volume_leite
  , (case when ((select count(*) from aplicacaoproduto where cdanimal = an.cdanimal and cdproduto in (select first 1 cdproduto from produto where upper(nome) like '%BOOSTIN%') and dtaplicacaoproduto >= (coalesce((select max(dtinicio) from lactacao where cdanimal = an.cdanimal), an.dtnascimento))) > 0 ) then 'Sim' else 'No' end)  as boostin
  , (l.dtleite - uboostin.dtaplicacaoproduto) as dias_apos_ultima_aplicacao_boostin
  , (pboostin.dtaplicacaoproduto - uboostin.dtaplicacaoproduto) as intervalo_aplicacao_boostin
from animal an
  join leite l on l.cdanimal = an.cdanimal
  join lactacao lac on lac.cdlactacao = l.cdlactacao
  left join aplicacaoproduto uboostin on uboostin.cdaplicacaoproduto = 
    (select first 1 re.cdaplicacaoproduto
    from aplicacaoproduto re
    where  re.cdanimal = l.cdanimal
      and re.dtaplicacaoproduto < l.dtleite
      and re.dtaplicacaoproduto > lac.dtinicio
    order by re.dtaplicacaoproduto desc)
  left join aplicacaoproduto pboostin on pboostin.cdaplicacaoproduto = 
  	(select first 1 re.cdaplicacaoproduto
    from aplicacaoproduto re
    where  re.cdanimal = l.cdanimal
      and re.dtaplicacaoproduto > uboostin.dtaplicacaoproduto
    order by re.dtaplicacaoproduto asc)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is null
  and l.dtleite >= coalesce((select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc), an.dtnascimento)
  -- COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 365)
  -- AND AN.CDANIMAL IN (SELECT CDANIMAL FROM LACTACAO WHERE COALESCE(DTFIM, '2200-12-31') > (CURRENT_DATE - 31))
order by an.numordenado