select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from p.dtpeso) < 10
        then '0'|| extract(day from p.dtpeso)
      else extract(day from p.dtpeso) end)
    || '/'
    || (case
      when extract(month from p.dtpeso) < 10
        then '0' || extract(month from p.dtpeso)
      else extract(month from p.dtpeso) end)
    || '/'
    || extract(year from p.dtpeso) as data_pesagem
  , cast(p.peso as integer) as peso
  , '' as altura
from animal an
  join peso p on p.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = an.cdanimal
    order by re.dtpeso desc)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  -- P.DTPESO > (CURRENT_DATE - 31)
